/*
 * Criao de uma nova thread, com envio de valor de retorno (endereo
 * de varivel alocada dinamicamente).
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>


void* f_thread(void *v) {
  int *retorno = (int *) malloc (sizeof(int));
  printf("Nova Thread ir retornar 256.\n");
  *retorno = 256;
  return (void*) retorno;
}

int main() {
  pthread_t thr;
  int* retorno_thr;

  pthread_create(&thr, NULL, f_thread, NULL);
  
  pthread_join(thr, (void**) &retorno_thr);

  printf("Valor de retorno: %d\n", *retorno_thr);

  free(retorno_thr); 
  
  return 0;
}
