/*
 * Criao de uma nova thread, com envio de valor de retorno (endereo
 * de varivel global).
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

int retorno; /* Varivel global */

void* f_thread(void *v) {
  printf("Nova Thread ir retornar 256.\n");
  retorno = 256;
  return (void*) &retorno;
}

int main() {
  pthread_t thr;
  int* retorno_thr;

  pthread_create(&thr, NULL, f_thread, NULL);
  
  pthread_join(thr, (void**) &retorno_thr);

  retorno = 57; /* Acesso  varivel global por outra
		   thread pode invalidar o processo */
  
  printf("Valor de retorno: %d\n", *retorno_thr);

  return 0;
}
